/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package com.sos.scheduler.engine.kernel.scripting;

/**
 * \file Script.java
 * \brief General Interface for javax.script package 
 *  
 * \class Script
 * \brief General Interface for javax.script package 
 * 
 * \details
 * This interface should be used from classes which implements a layer for
 * scripting via the javax.script package.
 *
 * \author ss
 * \version 1.0 - 18.01.2011 11:17:54
 * <div class="sos_branding">
 *   <p>(c) 2011 SOS GmbH - Berlin (<a style='color:silver' href='http://www.sos-berlin.com'>http://www.sos-berlin.com</a>)</p>
 * </div>
 */
public interface Script {
    public Object call(String name) throws NoSuchMethodException;
    public Object call(String rawfunctionname, Object[] params) throws NoSuchMethodException;
    public Object call();
    public boolean callBoolean(String name) throws NoSuchMethodException;
    public boolean callBoolean(String name, Object[] params) throws NoSuchMethodException;
    public String callString(String name) throws NoSuchMethodException;
    public String callString(String name, Object[] params) throws NoSuchMethodException;
    public double callDouble(String name) throws NoSuchMethodException;
    public double callDouble(String name, Object[] params) throws NoSuchMethodException;
    public void addObject(Object object, String name);
    public String getLanguageId();
	public String getSourcecode();
	public ScriptFunction getLastFunction();
}
