/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package com.sos.scheduler.model.commands;

import org.apache.log4j.Logger;

import com.sos.scheduler.model.SchedulerObjectFactory;
import com.sos.scheduler.model.answers.Ok;
import com.sos.scheduler.model.answers.Task;
import com.sos.scheduler.model.objects.Params;

/**
* \class JSCmdStartJob 
* 
* \brief JSCmdStartJob - 
* 
* \details
*
* \section JSCmdStartJob.java_intro_sec Introduction
*
* \section JSCmdStartJob.java_samples Some Samples
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author KB
* @version $Id$18.01.2011
* \see reference
*
* Created on 18.01.2011 18:28:20
 */

public class JSCmdStartJob extends StartJob {

	private final String		conClassName	= "JSCmdStartJob";
	@SuppressWarnings("unused")
	private static final Logger	logger			= Logger.getLogger(JSCmdStartJob.class);

	public JSCmdStartJob(SchedulerObjectFactory schedulerObjectFactory) {
		super();
		objFactory = schedulerObjectFactory;
	}

	/**
	 * 
	 * \brief getTask
	 * 
	 * \details
	 *
	 * \return Task
	 *
	 * @return
	 */
	public Task getTask() {

		@SuppressWarnings("unused")
		final String conMethodName = conClassName + "::getTask";
		Task objTask = null;
		Ok objOK = this.getAnswer().getOk();

		if (objOK != null)
			objTask = objOK.getTask();

		return objTask;
	} // private Task getTask

	/**
	 * 
	 * \brief setParams
	 * 
	 * \details
	 *
	 * \return Params
	 *
	 * @param pstrParamArray
	 * @return
	 */
	public Params setParams(String[] pstrParamArray) {

		@SuppressWarnings("unused")
		final String conMethodName = conClassName + "::setParams";

		Params objParams = objFactory.setParams(pstrParamArray);
		super.setParams(objParams);

		return objParams;
	} // private Params setParams

	// @Override
	// public Object unMarshal(File pobjFile) {
	// return objFactory.unMarshall(pobjFile);
	// }
	//
	// @Override
	// public Object marshal(Object objO, File objF) {
	// return objFactory.marshal(objO, objF);
	// }
	//
	// @Override
	// public String toXMLString(Object objO) {
	// return objFactory.toXMLString(objO);
	// }
	//
	// @Override
	// public String toXMLString() {
	// return objFactory.toXMLString(this);
	// }
	//
	// @Override
	// public void run() {
	// objFactory.run(this);
	// }
}
