/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// Soscopy_copying_dialog.cxx : implementation file
//

#include "afxwin.h"
#include <sos.h>
#include <msec.h>
#include "soscopy.h"
#include <soscopy.hrc>
#include "Soscopy_copying_dialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Soscopy_copying_dialog dialog

const int timer_id = 1;

Soscopy_copying_dialog::Soscopy_copying_dialog(CWnd* pParent /*=NULL*/)
	: CDialog(Soscopy_copying_dialog::IDD, pParent),
    _zero_(this+1)
{
	//{{AFX_DATA_INIT(Soscopy_copying_dialog)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void Soscopy_copying_dialog::stop_timer()
{
    KillTimer( timer_id );
}


BEGIN_MESSAGE_MAP(Soscopy_copying_dialog, CDialog)
	//{{AFX_MSG_MAP(Soscopy_copying_dialog)
	ON_WM_TIMER()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Soscopy_copying_dialog message handlers

BOOL Soscopy_copying_dialog::OnInitDialog() 
{
    CenterWindow();
	CDialog::OnInitDialog();
	
    SetTimer( timer_id, 100, NULL );
    _start_msec = elapsed_msec();
	
	return FALSE;  // return TRUE unless you set the focus to a control
	               // EXCEPTION: OCX Property Pages should return FALSE
}


void Soscopy_copying_dialog::OnDestroy() 
{
    KillTimer( timer_id );
	CDialog::OnDestroy();
}



void Soscopy_copying_dialog::OnCancel() 
{
    _abort = true;

    SendDlgItemMessage( IDCANCEL, BN_PUSHED );
	
	//CDialog::OnCancel();
}


void Soscopy_copying_dialog::OnTimer(UINT nIDEvent) 
{
    SetDlgItemInt( IDC_COPYING_SEC, ( elapsed_msec() - _start_msec ) / 1000 );
    SetDlgItemInt( IDC_COPYING_COPIED, _copied );
	CDialog::OnTimer(nIDEvent);
}



