/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// olestd.cxx                                 (C)1997 SOS GmbH Berlin
//                                            Joacim Zschimmer
// #rev 2#

#include "precomp.h"

//#define MODULE_NAME "hostole"
//#define AUTHOR      "Joacim Zschimmer"
//#define COPYRIGHT   "(C)1996 SOS GmbH Berlin"

#include <stdio.h>          // sprintf


#ifdef SYSTEM_MFC
#   include <afxdisp.h>
#else
#   include <windows.h>
#endif

#include <shellapi.h>

#include "sos.h"
#include "log.h"
#include "sysxcept.h"
#include "sosprof.h"
#include "sosfield.h"
#include "sosdate.h"
#include "stdfield.h"
#include "licence.h"
#include "../file/anyfile.h"

#include <ole2ver.h>

#define INITGUIDS
#include "olestd.h"
#include "olereg.h"

using namespace std;
namespace sos {


const LCID   std_lcid = (LCID)0;   //LOCALE_SYSTEM_DEFAULT;
const Variant      empty_variant;


//--------------------------------------------------------------ostream& operator << _com_error

ostream& operator << ( ostream& s, const _com_error& x )
{
    char buffer [30];
    sprintf( buffer, "MSWIN-%08X  ", x.Error() );
    s << buffer << get_mswin_msg_text( x.Error() );
    if( x.Description() != NULL )  s << " / " << x.Description();
    return s;
}

//-------------------------------------------------------------------------------------as_bool

bool as_bool( const VARIANT& variant )
{
    return as_bool( as_string( variant ) );
}

//-----------------------------------------------------------------------------------as_double

double as_double( const VARIANT& variant )
{
    Variant v = variant;
    v.ChangeType( VT_R8 );
    return v.dblVal;
}

//-----------------------------------------------------------------------------------as_bstr_t

_bstr_t as_bstr_t( const Big_int i )
{
    return as_bstr_t( as_string( i ) );
}

//-----------------------------------------------------------------------------------as_bstr_t

_bstr_t as_bstr_t( const Ubig_int i )
{
    return as_bstr_t( as_string( i ) );
}

//-----------------------------------------------------------------------------------as_bstr_t

_bstr_t as_bstr_t( const int i )
{ 
    return as_bstr_t( (Big_int)i ); 
}

//-----------------------------------------------------------------------------------as_bstr_t

_bstr_t as_bstr_t( const uint i )
{ 
    return as_bstr_t( (Ubig_int)i ); 
}

//---------------------------------------------------------------------------------operator == 
                 
bool operator == ( const _bstr_t& bstr, const string& str )  
{ 
    return as_string(bstr) == str; 
}

//---------------------------------------------------------------------------------operator == 

bool operator == ( const _bstr_t& bstr, const char* str )    
{ 
    return bstr == as_bstr_t(str); 
}


} //namespace sos
