/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
/* soslist.h                                            (c) SOS GmbH Berlin
                                                        Joacim Zschimmer
*/

#ifndef __SOSLIST_H
#define __SOSLIST_H

/* Sos_simple_list<T> ist eine einfach Listenimplementierung, wie sie aus funktionalen Sprachen
   bekannt ist. Es gibt kein Objekt, das die Liste als Ganzes beschreibt.
   list :  (objekt,list_ptr)
   list_ptr :  null | list*
*/

struct Sos_simple_list_0_elem;

struct Sos_simple_list_0        // Zeiger auf eine Liste oder auf NULL
{
                                Sos_simple_list_0       ();
                                Sos_simple_list_0       ( Sos_simple_list_0_elem* elem_ptr );
    virtual                    ~Sos_simple_list_0       ();

    Bool                        empty                   () const;
    int                         length                  () const;
    Sos_simple_list_0_elem*     operator->              () const;
    Sos_simple_list_0_elem*     elem_ptr                () const;
    void                        elem_ptr                ( Sos_simple_list_0_elem* );

  protected:
  //                            Sos_simple_list_0       ( const Sos_simple_list_0& );

  //Sos_simple_list_0           tail                    () const;
  //Sos_simple_list_0           last                    () const;

  private:
    Sos_simple_list_0_elem*    _elem_ptr;
};

/*
struct Sos_referenced_counted
{
                                Sos_referenced_counted  () : _ref_count( 1 )  {}
};
*/

struct Sos_simple_list_0_elem        // Liste ohne Objekte, Helferklasse fr Sos_simple_list<T>
{
    virtual                    ~Sos_simple_list_0_elem  ();

  protected:
                                Sos_simple_list_0_elem  ();
                                Sos_simple_list_0_elem  ( const Sos_simple_list_0& tail );
    //                          Sos_simple_list_0_elem  ( const Sos_simple_list_0_elem& );  // Deep copy!
    Sos_simple_list_0           tail                    () const;
    Sos_simple_list_0           last                    ();
    Sos_simple_list_0_elem*     last_elem_ptr           ();

    Sos_simple_list_0          _tail;
    int                        _ref_count;

  friend class Sos_simple_list_0;
};


template< class T >  struct Sos_simple_list_elem;

template< class T >
struct Sos_simple_list : Sos_simple_list_0
{
                                Sos_simple_list         ();                     // Empty list
  //                            Sos_simple_list         ( const Sos_simple_list_0& );
                                Sos_simple_list         ( const T&, const Sos_simple_list<T>& tail );
                                Sos_simple_list         ( const T& );
  //?                           Sos_simple_list         ( Sos_simple_list_elem<T>* );

    Bool                        empty                   () const;
    int                         length                  () const;
    Sos_simple_list_elem<T>*    operator->              () const;
  //T                           head                    () const;
  //T*                          head_ptr                () const;
  //Sos_simple_list<T>          tail                    () const;
  //Sos_simple_list<T>          last                    ();
  //T*                          element_ptr             ( int );
    void                        insert                  ( const T& );
    void                        append                  ( const T& );

    void                        store                   ( ostream& );
    Sos_simple_list_elem<T>&    load                    ( istream& );

  protected:
    Sos_simple_list_0_elem*     elem_ptr                () const;
};


template< class T >
struct Sos_simple_list_elem : Sos_simple_list_0_elem
{
                                Sos_simple_list_elem    ( const T&, const Sos_simple_list<T>& tail );
                                Sos_simple_list_elem    ( const T& );

    T                           head                    () const;
    T*                          head_ptr                () const;
    Sos_simple_list<T>          tail                    () const;
    Sos_simple_list<T>          last                    () const;
  //T*                          element_ptr             ( int );
    void                        append                  ( const T& );
                                operator Sos_simple_list<T> () const;

  private:
    Sos_simple_list_0          _tail;
    T                          _object;

  friend class Sos_simple_list<T>;
  friend class Sos_simple_list_0;
  friend class Sos_simple_list_0_elem;
};

#include "soslist.inl"
#endif
