/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// typereg.h                        1995 SOS GmbH Berlin           Joacim Zschimmer

#ifndef __TYPEREG_H
#define __TYPEREG_H

namespace sos
{

struct Type_register : Sos_self_deleting
{
    struct Entry
    {
                                Entry                   ();
                               ~Entry                   ();

        Sos_string             _name;
        Sos_ptr<Field_type>    _type;
    };

                                Type_register           ();
                               ~Type_register           ();

    void                        add                     ( const Sos_ptr<Field_type>&, const char* name );
    void                        add                     ( const Sos_ptr<Field_type>&, const Sos_string& name );
    void                        add                     ( const Sos_ptr<Record_type>& );

    Sos_ptr<Field_type>         type                    ( const char* );
    Sos_ptr<Field_type>        _type                    ( const char* );   // ohne Exception
    Sos_ptr<Record_type>        record_type             ( const char* );

  private:
    Fill_zero                  _zero_;
    int                        _last_used_index;
    Sos_simple_array<Entry>    _array;
};


Type_register* type_register_ptr();

} //namespace sos

#endif

