/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// $Id: log_categories.js 13686 2008-09-30 13:43:01Z jz $


//----------------------------------------------------------------------------------------------var

var static_log_categories_stylesheet = null;
var _scheduler = null;
var static_log_categories_dom;

//----------------------------------------------------------------------------------------do_onload

function do_onload()
{
    show_log_categories();
}

//------------------------------------------------------------------------------show_log_categories

function show_log_categories()
{
    if( !static_log_categories_stylesheet )  static_log_categories_stylesheet = new Stylesheet( "log_categories.xslt" );
    if( !_scheduler )  _scheduler = new Scheduler();

    window.parent.document.title = "Scheduler " + document.location.host + " Log categories";

    static_log_categories_dom = _scheduler.execute( "<scheduler_log.log_categories.show/>" );
    
    document.getElementById( "stylesheet_output" ).innerHTML = static_log_categories_stylesheet.xml_transform( static_log_categories_dom );
}

//------------------------------------------------------------------------------------execute_input

function execute_input()
{
    var commands = new Array();
    
    var log_categories = static_log_categories_dom.selectNodes( "//log_categories/log_category" );
    
    for( var i = 0; i < log_categories.length; i++ )
    {
        var log_category = log_categories[ i ];
        var path         = log_category.getAttribute( "path" )

        var checkbox = document.getElementById( "checkbox_log_category__" + path );
        if( checkbox )
        {
            var checked = checkbox.checked != false;
            if( checked != ( log_category.getAttribute( "value" ) != '0' ) )
            {
                commands.push( "<scheduler_log.log_categories.set category='" + path + "' value='" + checked + "'/>" );
            }
        }
    }
    
    var delay_input = document.getElementById( "delay_input" );
    if( delay_input ) 
    {
        var delay = 1*delay_input.value;
        if( delay )  commands.push( "<scheduler_log.log_categories.reset delay='" + delay + "'/>" );
    }
    
    if( commands.length > 0 )  
    {
        _scheduler.execute( "<commands>" + commands.join( "" ) + "</commands>" );
    }
    
    show_log_categories();
}

//-----------------------------------------------------------------------------reset_button_onclick

function reset_button_onclick()
{
    _scheduler.execute( "<scheduler_log.log_categories.reset/>" );
    show_log_categories();
}

//-------------------------------------------------------------------------------------------------
