/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// $Id: spooler_module_internal.cxx 13855 2010-04-29 15:36:16Z jz $        Joacim Zschimmer, Zschimmer GmbH, http://www.zschimmer.com

#include "spooler.h"

namespace sos {
namespace scheduler {

//-----------------------------------------------------------------Internal_module::Internal_module
    
Internal_module::Internal_module( Spooler* spooler, Prefix_log* log )
:
    Module( spooler, (File_based*)NULL, "::NO-INCLUDE-PATH::", log )
{
    _kind = kind_internal;
    _set = true;
}

//---------------------------------------------------Internal_instance_base::Internal_module_instance
    
Internal_module_instance::Internal_module_instance( Module* module )             
: 
    Module_instance(module),
    _zero_(this+1)
{
}

//----------------------------------------------------------------Internal_module_instance::add_obj
    
void Internal_module_instance::add_obj( IDispatch* idispatch, const string& name )
{
    if( name == "spooler_task" )
    {
        ptr<Com_task> com_task = dynamic_cast<Com_task*>( idispatch );
        _task = com_task->task();
    }
    else
    if( name == "spooler_log" )
    {
        ptr<Com_log> com_log = dynamic_cast<Com_log*>( idispatch );
        _log = com_log->log();
    }
}

//-------------------------------------------------------------------Internal_module_instance::call

Variant Internal_module_instance::call( const string& name )
{
    if( name == spooler_process_name )  return spooler_process();
    return false;
}

//-------------------------------------------------------------------Internal_module_instance::call

Variant Internal_module_instance::call( const string&, const Variant&, const Variant& )
{
    assert(0), z::throw_xc( Z_FUNCTION );
}

//------------------------------------------------------------Internal_module_instance::name_exists

bool Internal_module_instance::name_exists( const string& name )
{
    if( name == spooler_process_name )  return true;

    return false;
}

//-------------------------------------------------------------------------------------------------

} //namespace scheduler
} //namespace sos

