/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// $Id: perl_scripting_engine_module.cxx 13491 2008-04-16 10:16:11Z jz $                                (C)1996 SOS GmbH Berlin
// Joacim Zschimmer

#include "zschimmer.h"
#include "z_com.h"
#include "com_server.h"
#include "log.h"
#include "perl_scripting_engine.h"

using namespace zschimmer;
using namespace zschimmer::com;


//------------------------------------------------------------------------------------------DllMain

#ifdef Z_LINK_STATIC
#   define DllMain sosperl_DllMain
#endif

extern "C" BOOL WINAPI DllMain( HANDLE hInst, DWORD ul_reason_being_called, void* param )
{
    BOOL result = TRUE;

    switch( ul_reason_being_called )
    {
        case DLL_PROCESS_ATTACH: 
        {
            try 
            {
                zschimmer_init();
            }
            catch( const Xc& x ) 
            { 
                fprintf( stderr, "%s DLL_PROCESS_ATTACH  ERROR  %s\n", Z_FUNCTION.c_str(), x.what() );
                result = FALSE; 
            }
            break;
        }

        case DLL_PROCESS_DETACH: 
        {
            zschimmer_terminate();
            break;
        }

      //case DLL_THREAD_ATTACH : break;
      //case DLL_THREAD_DETACH : break;

        case Z_DLL_COM_ATTACH: 
        {
            Apply_com_module_params( (Com_module_params*)param );
            result = TRUE;
            break;
        }

        default: break;
    } 

    return result;
}

//----------------------------------------------------------------------------DllGetClassObject

#ifdef Z_LINK_STATIC
#   define DllGetClassObject sosperl_DllGetClassObject
#endif

extern "C" HRESULT APIENTRY DllGetClassObject( const CLSID& clsid, const IID& iid, void** result )
{
    if( CLSID_PerlScript == CLSID_NULL )    {        fprintf( stderr, "*** Die statischen Variablen im PerlScript-Modul sind nicht initialisiert! ***\n" );    }

    //if( clsid == CLSID_PerlScript )  return com_get_class_object( perl_class_descriptor, clsid, iid, result );
    //if( clsid == CLSID_PerlScript )  return com_get_class_object( create_perl_scripting_engine, clsid, iid, result );

    HRESULT hr = CLASS_E_CLASSNOTAVAILABLE;
    
    if( clsid == CLSID_PerlScript )  hr = Create_perl_scripting_engine( clsid, iid, result );

    if( FAILED(hr) )  fprintf( stderr, "Perl DllGetClassObject(%s) => %x\n", string_from_clsid( clsid ).c_str(), hr );
    return hr;
}

//------------------------------------------------------------------------------DllCanUnloadNow
/*

extern "C" int WINAPI DllCanUnloadNow()
{
    LOG( "DllCanUnloadNow: com_object_count=" << sos::com_object_count << ", com_lock=" << sos::com_lock << '\n' );

    try 
    {
        if( sos::com_object_count == 0  &&  sos::com_lock == 0 ) 
        {
            hostole_appl.exit();
            return S_OK;
        }
        else
        {
            sos_alloc_list( log_ptr );   // Zeigt alle angeforderten Datenbereiche, nur bei [debug] check-new=yes
            return S_FALSE;
        }
    } 
    catch(...) 
    {
        // Trotzdem entladen ...
        return S_OK;
    }
}

*/
