/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// $Id: string_stream.h 13579 2008-06-09 08:09:33Z jz $

#ifndef __ZSCHIMMER_STRING_STREAM_
#define __ZSCHIMMER_STRING_STREAM_

namespace zschimmer {

//------------------------------------------------------------------------------------String_stream
// Beispiel: _log.info( S() << "i=" << 42 << " bool" << true );
namespace com {}

struct String_stream : std::ostringstream
{
                                String_stream           ();
                               ~String_stream           ();


  //template< typename TYPE >
  //String_stream( const TYPE& first )
  //{ 
  //    //error C4717: Rekursiv fr alle Steuerelementpfade. Die Funktion verursacht einen Stapelberlauf zur Laufzeit.
  //    *static_cast<std::ostringstream*>( this ) << first; 
  //}


    template< typename TYPE >
    String_stream& operator = ( const TYPE& first )
    { 
        clear();
        append( first );
        return *this;
    }


    template< typename TYPE >
    void append( const TYPE& value )
    { 
        using namespace com;    // Fr VARIANT und BSTR
        
        *static_cast<std::ostringstream*>( this ) << value;
    }


    void append( const char* s, size_t length )
    {
        assert( (std::streamsize)length >= 0 );
        std::ostringstream::write( s, (std::streamsize)length );
    }


    template< typename TYPE >
    String_stream& operator<< ( const TYPE& value )
    { 
        using namespace com;    // Fr VARIANT und BSTR
        
        append( value );
        return *this; 
    }


                                operator string         () const                                    { return to_string(); }
    string                      to_string               () const                                    { return str(); }
    bool                        empty                   ()                                          { return length() == 0; }
    size_t                      length                  ();
    void                        truncate                ( size_t );
    void                        clear                   ()                                          { truncate( 0 ); }
    friend ostream&             operator <<             ( ostream& s, const String_stream& ss )     { return s << ss.str(); }
};

/*

struct String_stream 
{
                                String_stream           ();
                               ~String_stream           ();


    template< typename TYPE >   String_stream           ( const TYPE& first )                       { _ostringstream << first; }
 

    //template< typename TYPE >
    //String_stream& operator<< ( const TYPE& value )
    //{ 
    //    using namespace com;    // Fr VARIANT und BSTR
    //    
    //    _ostringstream << value;
    //    return *this; 
    //}


                                operator string         () const                                    { return to_string(); }
    string                      to_string               () const                                    { return _ostringstream.str(); }
    bool                        empty                   ()                                          { return length() == 0; }
    size_t                      length                  ();
    void                        truncate                ( size_t length )                           { _ostringstream.seekp( length ); }
    friend ostream&             operator <<             ( std::ostream& s, const String_stream& ss ){ return s << ss._ostringstream.str(); }


    std::ostringstream         _ostringstream;
};


template< typename TYPE >
String_stream& operator<< ( String_stream& string_stream, const TYPE& value )
{ 
    string_stream._ostringstream << value;
    return string_stream; 
}
*/

typedef String_stream           S;

inline string                   operator +              ( const string &a, const String_stream& b )  { return a + b.to_string(); }
inline string                   operator +              ( const char* a  , const String_stream& b )  { return a + b.to_string(); }
inline string                   operator +              ( const String_stream& a, const string& b )  { return a.to_string() + b; }
inline string                   operator +              ( const String_stream& a, const char*   b )  { return a.to_string() + b; }

/*
inline S operator << ( const string& a, const string& b ) 
{
    return S() << a << b;
}
*/

//-------------------------------------------------------------------------------------------------

} //namespace zschimmer

#endif
