/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// $Id: z_md5.h 13199 2007-12-06 14:15:42Z jz $        Joacim Zschimmer, Zschimmer GmbH, http://www.zschimmer.com

#ifndef __ZSCHIMMER_Z_MD5_H
#define __ZSCHIMMER_Z_MD5_H

#include "z_io.h"

namespace zschimmer {

const int                       md5_sum_byte_count          = 16;

//----------------------------------------------------------------------------------------------Md5

struct Md5
{
                                Md5                         ()                                      { memset( _bytes, 0, sizeof _bytes ); }

                                operator string             () const                                { return to_string(); }
    bool                        operator ==                 ( const Md5& o ) const                  { return memcmp( _bytes, o._bytes, sizeof _bytes ) == 0; }
    bool                        operator !=                 ( const Md5& o ) const                  { return !( *this == o ); }

    void                    set_hex                         ( const string& hex );
    string                      to_string                   () const                                { return lcase_hex( _bytes, sizeof _bytes ); }

  private:
    friend struct               Md5_calculator;

    Byte                       _bytes[ md5_sum_byte_count ];
};


//-----------------------------------------------------------------------------------Md5_calculator

struct Md5_calculator
{
                                Md5_calculator              ();

    void                        add                         ( const io::Byte_sequence& );
    Md5                         md5                         ();

  private:
    third_party::md5::MD5_CTX  _md5_context;
    bool                       _finished;
};

//-------------------------------------------------------------------------------------------------

Md5                             md5                         ( const io::Byte_sequence& );

//-------------------------------------------------------------------------------------------------

} //namespace zschimmer

#endif
